#import "NetTalk.h"
#import <objc/Object.h>
#import <appkit/View.h>
#import <appkit/Window.h>
#import <remote/NXProxy.h>
#import <bsd/sys/param.h>


@interface NetTalkClient : Object <NXSenderIsInvalid, NTKPclient>
{
/* NXProxy for server */
	id	       server;
	id         delegate;
	BOOL       serverStarter;
	
/* strings / string pointer */
	char       currentServerName[256];
	char       talkName[MAXPATHLEN];
	char       hostname[MAXPATHLEN];
	char      *realName;
	char       uniqueName[MAXPATHLEN];
	char       registrationKey[13];
}

/* handling the delegate */
- setDelegate:aDelegate;
- delegate;

/* getting the real user name from NetInfo */
- (const char *)user;
- (const char *)fullHostname;

/* handling the server */
- startupServer;
- (int)thereIsNoServer;
- server;
- (const char *)serverName;

/* for shareware */
- (const char *)registrationKey;
- (int)registrationNr;


/*****************************************************************/
/* Methods the delegate and other interested folks should invoke */
/*****************************************************************/

- (id)
	sendRefuseTo:(const char *)uName
		forCode:(const char *)aCode;

- (id)
	sendConnectTo:(const char *)uName
		via:aDocument
		withCode:(const char *)aCode
		topicIs:(const char *)aTopic;

- (id)
	sendDisconnectTo:(const char *)uName
		forCode:(const char *)aCode;

@end

@interface Object (NetTalkClientDelegate)

- (id) updateClientData;

- (id) handleRefuseFrom:(const char *)aClientUName
		forCode:(const char *)aCode;

- (id) handleConnectFrom:(const char *)aClientUName
		via:aDocument
		withCode:(const char *)aCode
		topicIs:(const char *)aTopic;

- (id) handleDisconnectFrom:(const char *)aClientUName
		forCode:(const char *)aCode;

@end
